// Faan Tone Liu  01/17/02
// Binary search function, and testing it

#include <iostream>
#include <fstream>

using namespace std;
int binarySearch(const int b[], int searchkey, int size);
void bubble_sort(int a[], int len);

// read elements of an array in from a file.  Sort them.
// Get search key from user, search for it in array.
int main()
{
    const int maxarrlen(100);
    const int maxnamelen(80);
    char filename[maxnamelen];
    ifstream listfile;
    int arr[maxarrlen];
    int numelements(0);
    int key, result;

    cout << "Enter file name containing list (no more than 100 elements): ";
    cin >> filename;
    listfile.open(filename, ios::in);   // open input file
	if (!listfile.is_open()) {
            cout << "Unable to open file." << endl;
            return 1;
	}

    // read the list from the file into the array
    while (listfile >> arr[numelements])
        numelements = numelements + 1;

    //sort it
    bubble_sort(arr, numelements);

    cout << "What number are you looking for? ";
    cin >> key;
    result = binarySearch(arr, key, numelements);
    if (result < 0)
        cout << "The number was not found in the list" << endl;
    else 
       	cout << "The number " << key << " was found at position " << result <<
            " of the array." << endl;
    return 0;
}
							  
//Search through array b which contains size elements to locate the
// index of searchkey, a value we hope to find in b.  If it is
// not found, return -1
int binarySearch(const int b[], int searchkey, int size)
{
    int low, middle, high;

    low = 0;
    high = size-1;
    while (low <= high) {
        middle = (low+high)/2;
        if (searchkey == b[middle])      // found it!
            return middle;
        else if (searchkey < b[middle])  // it's in the lower half
            high = middle -1;
        else
            low = middle + 1;
    }

    return -1;
}

// sort the array a in increasing order
// Make n passes through the list.  In each pass, compare adjacent pairs
// all the way along the array, switching if they're out of orders
void bubble_sort(int a[], int len)
{
    int i, j, temp;

    for (i=0; i < len; i++) {
        for (j = 0; j < len - i - 1; j++) {
            if (a[j] > a[j+1]) {
                temp = a[j+1];
                a[j+1] = a[j];
                a[j] = temp;
            }
        }
    }
}
